//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    face2.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#ifndef __bbox2_h
#define __bbox2_h

#include "typedefs.h"
#include "macros.h"
#include "dataobj.h"


// -------------------------------------------------------------------
// class tFace2 
//
// This class implements the functionalities of a square bounding box.
//
// -------------------------------------------------------------------

class tBBox2 : public tDataObject {
 public:
    // Standard class typedefs
    typedef tBBox2                Self;
    typedef tSmartPtr<Self>       Pointer;
    typedef tSmartPtr<const Self> ConstPointer;

    // Method for creating an instance of this object
    newMacro(Self);

    // Constructor
    tBBox2() {}

    // Destructor
    ~tBBox2() {}

    Point2 getPMin() const
      { return m_pmin; }

    Point2 getPMax() const
      { return m_pmax; }

    void setPMin(const Point2& p)
      { m_pmin = p; }

    void setPMax(const Point2& p)
      { m_pmax = p; }

 private:
    // Purposely not implemented
    tBBox2(const Self&);
    void operator=(const Self&); 

    //
    // Private Attributes 
    //

    Point2 m_pmin;     // lower-left point of this bounding box          
    Point2 m_pmax;     // upper-right point of this bounding box
};


#endif   // __bbox2_h
