//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    dataobj.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#ifndef __dataobj_h
#define __dataobj_h

#include <iostream>

class tDataObject {
public:
  tDataObject() : m_refcount(0) {}
  virtual ~tDataObject() {
    if (m_refcount > 0) {
      std::cout << "Trying to delete object with non-zero reference count" << std::endl;
    }
  }

  void addRef() {
    ++m_refcount;
  }

  void release() {
    --m_refcount;
    if (m_refcount == 0) delete this;
  }

  int getRef() const { return m_refcount; }

protected:

  // Counter for the number of references
  mutable int m_refcount;
};

#endif  // __dataobj_h
