//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    macros.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#ifndef __macros_h_
#define __macros_h_


// -------------------------------------------------------------------
//
// Macros used by mathematical routines.
//
// -------------------------------------------------------------------
const double TOL = 1e-10;
#define IS_EQUAL(a,b) ((fabs(a-b) < TOL))
#define IS_ZERO(x) ((fabs(x) < 1e-24))
const double MY_PI = 3.14159265;

// -------------------------------------------------------------------
//
// This macro  is used  to create an  instance of a  particular object
// using the  C++ operator "new", and  then return a  smart pointer to
// this object.
//
// -------------------------------------------------------------------
#define newMacro(c) \
static Pointer New(void) \
{ \
  c *dumbPtr = new c; \
  Pointer smartPtr(dumbPtr); \
  return smartPtr; \
}

#define treatException(e) \
  cout << "Exception: " << e.getDescription() << endl \
       << "File: " << e.getFile() << endl \
       << "Line: " << e.getLine() << endl;

#endif   // __macros_h
