//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    edge2.cc
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
// ===================================================================

#include "edge2.h"

namespace hedge {

  // -----------------------------------------------------------------
  // Method: getCommonVertex 
  // 
  // Returns a  smart pointer  to the common  vertex of this  edge and
  // another given edge.
  //
  // -----------------------------------------------------------------

  tEdge2::vtPointer
  tEdge2::getCommonVertex(const tEdge2::Pointer& e) const
  {
    hePointer he1 = this->getHalfEdge();
  
    vtPointer v1 = he1->getVertex();
    vtPointer v2 = he1->getNext()->getVertex();

    he1 = e->getHalfEdge();
  
    vtPointer v3 = he1->getVertex();
    vtPointer v4 = he1->getNext()->getVertex();

    if ((v1 == v3) || (v1 == v4)) return v1;
    if ((v2 == v3) || (v2 == v4)) return v2;

    return vtPointer(0);
  }

};    // end namespace hedge
