//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    face2attrib.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
// ===================================================================

#ifndef __face2attrib_h
#define __face2attrib_h

#include "macros.h"
#include "dataobj.h"

namespace hedge {

  // -----------------------------------------------------------------
  // class tFace2attrib
  //
  // This class represents attributes  of faces in the hadle-edge data
  // structure.  User  should extend this class to  create her/his own
  // attribute class.
  //
  // -----------------------------------------------------------------

  class tFace2Attrib : public tDataObject {
  public:
    // Standard class typedefs
    typedef tFace2Attrib          Self;
    typedef tSmartPtr<Self>       Pointer;
    typedef tSmartPtr<const Self> ConstPointer;

    // Method for creating an instance of this object
    newMacro(Self);
    
    tFace2Attrib() {}
    virtual ~tFace2Attrib() {}
  };

};

#endif   // __face2attrib_h
