//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    vertex2attrib.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
//  This software  is distributed  WITHOUT ANY WARRANTY;  without even
//  the  implied   warranty  of  MERCHANTABILITY  or   FITNESS  FOR  A
//  PARTICULAR PURPOSE.
//
//  ==================================================================

#ifndef __vertex2attrib_h
#define __vertex2attrib_h

#include "macros.h"
#include "smartptr.h"
#include "dataobj.h"

namespace hedge {

  // -----------------------------------------------------------------
  // class tVertex2attrib
  //
  // This class represents attributes of 2D vertices in the hadle-edge
  // data structure.  User should extend this class  to create her/his
  // own attribute class.
  //
  // -----------------------------------------------------------------

  class tVertex2Attrib : public tDataObject {
  public:
    // Standard class typedefs
    typedef tVertex2Attrib        Self;
    typedef tSmartPtr<Self>       Pointer;
    typedef tSmartPtr<const Self> ConstPointer;

    // Method for creating an instance of this object
    newMacro(Self);

    tVertex2Attrib() {}
    virtual ~tVertex2Attrib() {}
  };

};   // end namespace qmpp

#endif   // __vertex2attrib_h
