//  ===================================================================
//
//  Program:   Quadrilateral Mesh Post-Processor
//  Module:    quad2.h
//  Language:  C++
//  Date:      March 2003
//  Version:   1.0.0
//
//  Copyright (c) 2002, 2003
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#ifndef __quad2_h
#define __quad2_h

#include <vector>
#include <sstream>

#include "typedefs.h"
#include "exceptionobj.h"
#include "polygon2.h"

using namespace std;

namespace qmpp {

  // -----------------------------------------------------------------
  // class tQuad2
  //
  // This class represents a  particular polygon, a quadrilateral, and
  // it is a specialization of the class tPolygon2.
  //
  // -----------------------------------------------------------------
  class tQuadrilateral2 : public tPolygon2 {
  public:
     // Constructors
     tQuadrilateral2();
     tQuadrilateral2(const tQuadrilateral2&);
     tQuadrilateral2(const tPolygon2&) throw (tExceptionObject);
     tQuadrilateral2(tPolygon2*) throw (tExceptionObject);

     // Destructor
     ~tQuadrilateral2()
     {}

     // Assignment operators
     tQuadrilateral2 operator=(const tQuadrilateral2&);
     tQuadrilateral2 operator=(const tPolygon2&) throw (tExceptionObject);

     // Modifier
     void reverse();
  };

};    // end namespace qmpp


#endif   // __quad2_h
